unit Employee;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, StdCtrls, Mask,
  DBCGrids, Menus, Buttons, SBasic, About;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    EmployeeSheet: TTabSheet;
    ShowingSheet: TTabSheet;
    DataSource1: TDataSource;
    Table1: TTable;
    Label1: TLabel;
    Table1EmpNo: TIntegerField;
    Table1LastName: TStringField;
    Table1FirstName: TStringField;
    Table1PhoneExt: TStringField;
    Table1HireDate: TDateTimeField;
    Table1Salary: TFloatField;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query1OrderNo: TFloatField;
    Query1CustNo: TFloatField;
    Query1PaymentMethod: TStringField;
    Query1ItemsTotal: TCurrencyField;
    Query1TaxRate: TFloatField;
    Query1Freight: TCurrencyField;
    Query1AmountPaid: TCurrencyField;
    Query1ItemNo: TFloatField;
    Query1Qty: TIntegerField;
    Query1Discount: TFloatField;
    Query1PartNo: TFloatField;
    Query1Cost: TCurrencyField;
    Query1ListPrice: TCurrencyField;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    Panel5: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    DBEdit5: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    DBEdit6: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit2: TDBEdit;
    Panel6: TPanel;
    DBNavigator1: TDBNavigator;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel1: TPanel;
    Table2: TTable;
    DataSource3: TDataSource;
    Panel9: TPanel;
    DBGrid2: TDBGrid;
    DBNavigator2: TDBNavigator;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SBasic1: TSBasic;
    Panel10: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    TranslateButton: TButton;
    SaveButton: TButton;
    Memo1: TMemo;
    Table3: TTable;

    procedure FormCreate(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Exit1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TranslateButtonClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    Qty       : array[0..1000] of real;
    Cost      : array[0..1000] of real;
    ListPrice : array[0..1000] of real;
    N_items   : integer;
    Salary    : real;

    procedure ClearGrid;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function GetExeDir: string;
var  i, N: integer;
begin
     Result := Application.ExeName;
     N := Length( Result );
     for i:=1 to Length( Result ) do
         if Result[i] = '\' then N := i;
     SetLength( Result, N );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     Table2.DataBaseName := GetExeDir;
     Table2.Active := true;
     Table3.DataBaseName := GetExeDir;
     Memo1.Lines.LoadFromFile( GetExeDir + 'Example1.bas' );
     ChDir( GetExeDir );
     TranslateButton.Enabled := false;
     SaveButton.Enabled      := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     Table2.Active := false;
end;

procedure TForm1.ClearGrid;
var i: integer;
begin
     for i:=0 to StringGrid1.RowCount-1 do
     begin
          StringGrid1.Cells[0, i] := '';
          StringGrid1.Cells[1, i] := '';
     end;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
     ClearGrid;
     Query1.Close;
     Query1.Params[0].AsInteger := Table1.FieldByName('EmpNo').AsInteger;
     Query1.Active := true;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);

procedure Load_params;
begin
     DBGrid1.DataSource := nil;
     N_items := 0;
     Query1.First;
     while not Query1.Eof do
     begin
          Qty[ N_items ]  := TFloatField( Query1.FieldByName('Qty') ).AsFloat;
          Cost[ N_items ] := TFloatField( Query1.FieldByName('Cost') ).AsFloat;
          ListPrice[ N_items ] := TFloatField( Query1.FieldByName('ListPrice') ).AsFloat;
          inc( N_items );
          Query1.Next;
     end;
     Query1.First;
     DBGrid1.DataSource := DataSource2;
     Salary := Table1.FieldByName( 'Salary' ).AsFloat;

end;

procedure Set_params;
var i: integer;
begin
     SBasic1.Set_value( 'N_items', 0, N_items );
     SBasic1.Set_value( 'Salary', 0, Salary );
     for i := 0 to N_items-1 do
     begin
          SBasic1.Set_value( 'Qty',  i, Qty[ i ] );
          SBasic1.Set_value( 'Cost', i, Cost[ i ] );
          SBasic1.Set_value( 'ListPrice', i, ListPrice[ i ] );
     end;
end;

Function Get_result: ShortString;
var ID_RES: ShortString;
    str_res: ShortString;
    val_res: real;
begin
     ID_res := Table3.FieldByName('ID').AsString;
     val_res := SBasic1.Get_Value( ID_RES, 0 );
     str( val_res:12:2, str_res );
     Result := Trim( str_res );
end;

procedure Calculate;
var i:  integer;
begin
     SBasic1.Load_code;
     Set_params;
     SBasic1.Execute;
     i := 0;

     Table3.Open;
     Table3.First;
     while not Table3.Eof do
     begin
          StringGrid1.Cells[0, i] := Table3.FieldByName('Title').AsString;
          StringGrid1.Cells[1, i] := Get_result;
          Table3.Next;
          inc(i);
     end;
     Table3.Close;
     SBasic1.Fill_Watches;
end;

begin
     ClearGrid;
     Load_params;
     Calculate;
end;

procedure TForm1.TranslateButtonClick(Sender: TObject);
begin
     SBasic1.Translate;
     TranslateButton.Enabled := false;
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
begin
     Memo1.Lines.SaveToFile( GetExeDir + 'Example1.bas' );
     SaveButton.Enabled := false;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
     TranslateButton.Enabled := true;
     SaveButton.Enabled := true;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
     AboutBox.ShowModal;
end;

end.
